pipeline {
    environment {
    database_dir    = "kubernetes/database"
    wordpress_dir   = "kubernetes/wordpress"
    packages_dir    = "kubernetes/scripts/2-softwares"
    MARIADB_env     = "kubernetes/database/MARIADB_env"
    WORDPRESS_env   = "kubernetes/wordpress/WORDPRESS_env"
    release         =  "R2"
    
  }
    agent any
   
    stages {
        stage('Build an Image for DevOPs Wordpress') {
            steps {
              sh '''
                    echo $PWD
                    whoami
                    ls $PWD

                    echo "Installing Packages On Jenkins docker container"

                    apt update -y && apt-get install iputils-ping -y && apt-get install -y mysql-client

                    echo "checking the internet connectivity"

                    ping -c3 google.com

                    echo "Installing Latest AWScli, Terraform, Eksctl & Kubectl"

                    chmod +x $packages_dir/packages.sh

                    $packages_dir/packages.sh /usr/local/bin

                    aws --version

                    curl --silent --location "https://github.com/weaveworks/eksctl/releases/latest/download/eksctl_$(uname -s)_amd64.tar.gz" | tar xz -C /usr/local/bin

                    eksctl version

                    ls $wordpress_dir
                
                    echo 'Creating a docker image with Gitlab Tags Option ....navigate to Gitlab/Gitub/BitBucket Section & Create a TAG'
                    
                    apt update -y && apt install -y git
                
                    # Latest TAG

                    echo "We are pulling the latest TAG from our Gitlab/Gitub/BitBucket repo, the TAG we created from Console"
                    
                    echo $PWD

                    ls $PWD

                    git pull https://gitlab.com/muhammad.asim/devops-cicd.git

                    echo "Latest TAG COMMIT ID is mentioned below, navigate to your Gitlab/Gitub/BitBucket repo & check the latest TAG"
                  
                    COMMIT_ID=`git rev-list --tags --date-order | head -n1`

                    echo $COMMIT_ID

                    echo "Latest TAG is mentioned below"

                    TAG=`git show-ref --tags | grep "$COMMIT_ID" | awk -F / '{print $NF}' | head -n1`

                    echo $TAG
                    
                    git pull https://gitlab.com/muhammad.asim/devops-cicd.git
                    
                    
                    echo $TAG
                    
                    docker build -t quickbooks2018/devops:$TAG ./kubernetes/wordpress
                    

                    sleep 20

                    docker push quickbooks2018/devops:$TAG

                    echo  $WORDPRESS_env

                    cat   $WORDPRESS_env

                    chmod +x $wordpress_dir/create-wordpress-credentials.sh

                    $wordpress_dir/create-wordpress-credentials.sh /usr/local/bin
                    
                    kubectl apply -f $wordpress_dir/devops-wordpress.yaml

                    sleep 10

                    kubectl apply -f $wordpress_dir/storage.yaml

                    kubectl get pods
                    
            
            
                   '''
            }
        }
        stage('Creating Database for DevOps Wordpress') {
            steps {
                 sh '''
                    echo 'Creating Database for Cloudelligent WP'

                    echo  $MARIADB_env

                    cat   $MARIADB_env

                    chmod +x $database_dir/create-mariadb-credentials.sh

                    $database_dir/create-mariadb-credentials.sh /usr/local/bin

                    kubectl apply -f $database_dir/mariadb.yaml

                    sleep 10

                    kubectl apply -f $database_dir/storage.yaml

                    kubectl get pods

                    
                '''
            }
        }    
        
        stage('Automated Deployment & Release Migration') {
            steps {
            
                sh '''
                
                echo -e "\nAutomatic Deployment & Release Migration\n"
                
                kubectl get pvc
                
                kubectl get pv
                
                kubectl get statefulsets
                
                sleep 300
                
                WORDPRESS_POD=`kubectl get pods | grep -i wordpress | awk '{print $1}'`
                    
                echo "$WORDPRESS_POD"
            
            
                kubectl exec -n default $WORDPRESS_POD bash /opt/bitnami/wordpress/wp-content/releases/$release.sh
                
                '''
                
            }
        }
  
        }
    }

